<?php
// +-------------------------------------------------+
//  2002-2004 PMB Services / www.sigb.net pmb@sigb.net et contributeurs (voir www.sigb.net)
// +-------------------------------------------------+
// $Id: faq.class.php,v 1.6 2016-08-04 10:00:22 dgoron Exp $

if (stristr($_SERVER['REQUEST_URI'], ".class.php")) die("no access");

require_once($class_path."/faq_question.class.php");
require_once($include_path."/navbar.inc.php");
require_once($class_path."/analyse_query.class.php");

//classe grant la visualisation du module FAQ  l'OPAC...
class faq {
	public $themes = array();
	public $types = array();
	public $descriptors = array();
	public $years;
	public $questions_ids = array();
	public $questions = array();
	public $nb_questions_by_page=0;
	public $page;
	public $filters =array();
	public $user_query = "";

	public function __construct($page=1, $nb_questions_by_page=0,$filters=array()){
		global $opac_search_results_per_page;
		$this->page = ($page*1);
		if($this->page>=1) $this->page-=1;
		$this->nb_questions_by_page = ($nb_questions_by_page ? $nb_questions_by_page : $opac_search_results_per_page);
		$this->themes = array_filter(($filters['themes'] ? $filters['themes'] : array()));
		$this->types = array_filter(($filters['types'] ? $filters['types'] : array()));
		$this->descriptors = array_filter(($filters['descriptors'] ? $filters['descriptors'] : array()));
		$this->years = array_filter(($filters['years'] ? $filters['years'] : array()),function($var){return ($var!=="");});
		$this->user_query = trim($filters['user_query']);
		
		$this->fetch_datas();
	}
	
	protected function fetch_datas(){
		global $dbh;
		$query = "select id_faq_question from faq_questions !!join!!!!where!! order by faq_question_question_date desc, faq_question_answer_date desc";
		$join = $where= array();
		$where[] = ($_SESSION["id_empr_session"] ? "faq_question_statut in (2,3)" : "faq_question_statut = 2");
		if(count($this->themes)){
			$where[] = "faq_question_num_theme in (".implode(",",$this->themes).")";
		}
		if(count($this->types)){
			$where[] = "faq_question_num_type in (".implode(",",$this->types).")";
		}
		if(count($this->descriptors)){
			$join[] = "join faq_questions_categories on id_faq_question=num_faq_question ";
			$where[] = "num_categ in (".implode(",",$this->descriptors).")";
		}
		if(count($this->years)){
			$where[] = "year(faq_question_answer_date) in (".implode(",",$this->years).")";
		}
		$query = str_replace("!!join!!",implode(" ",$join),$query);
		if(count($where)){
			$where = implode(" and ",$where);
			$query = str_replace("!!where!!","where ".$where,$query);
		}else $query = str_replace("!!where!!","",$query);

		$result = pmb_mysql_query($query);
		if(pmb_mysql_num_rows($result)){
			$this->questions_ids = array();
			while($row = pmb_mysql_fetch_object($result)){
				$this->questions_ids[] = $row->id_faq_question;
			}
		}
		
		if($this->user_query){
			$aq = new analyse_query($this->user_query);
			$query = $aq->get_query_mot("id_faq_question", "faq_questions_words_global_index", "word","faq_questions_fields_global_index", "value");
			$query.= " where id_faq_question in(".implode(",",$this->questions_ids).")";
			$this->questions_ids = array();
			$result = pmb_mysql_query($query);
			if(pmb_mysql_num_rows($result)){
				while($row = pmb_mysql_fetch_object($result)){
					$this->questions_ids[] = $row->id_faq_question;
				}
			}
		}
	}
	
	protected function get_page_title(){
		global $msg,$charset;
		$title = sprintf($msg['faq_question_page_title'],count($this->questions_ids));

		
		return $title;
	}
	
	public function show(){
		global $include_path;		
		$html="
		<script type='text/javascript' src='".$include_path."/javascript/faq.js'></script>
		<div class='faq' id=faq'>
			<h3>".$this->get_page_title()."</h3>
			<div class='row'>&nbsp;</div>
			<div class='faq_content'>";
		$start = $this->page * $this->nb_questions_by_page;
		$end =$start+$this->nb_questions_by_page;
		for($i=$start ; $i<$end ; $i++){
			if(isset($this->questions_ids[$i])){
				$this->question[$this->questions_ids[$i]] = new faq_question($this->questions_ids[$i]);
				$html.=$this->question[$this->questions_ids[$i]]->get_listview();
			}
		}
		$html.="
			</div>
			".$this->get_navigator()."
		</div>";
		return $html;
	}
	
	protected function get_navigator(){
		if(count($this->questions_ids)){
			$url_page = "javascript:document.faq_filters.faq_page.value=!!page!!;document.faq_filters.submit()";
			$nb_per_page_custom_url = "javascript:document.faq_filters.nb_per_page_custom.value=!!nb_per_page_custom!!";
			$action = "javascript:document.faq_filters.faq_page.value=document.form.page.value;document.faq_filters.submit()";
			return "
			<div id='navbar'>
				<hr />
				<center>
					".printnavbar($this->page+1, count($this->questions_ids), $this->nb_questions_by_page, $url_page, $nb_per_page_custom_url, $action)."
				</center>
			</div>";
		}
	}
	
	protected function init_filters_infos(){
		global $dbh,$msg;

		//thmes
		$themes = $this->get_facette_informations(3,1);
		if(count($themes)) $this->filters['themes'] = $themes;
		//types
		$types = $this->get_facette_informations(4,1);
		if(count($types)) $this->filters['types'] = $types;
		//descripteurs
		$descriptors = $this->get_facette_informations(6,1);
		if(count($descriptors))	$this->filters['descriptors'] = $descriptors;
		//descripteurs
		$years = $this->get_facette_informations(9,0);
		if(count($years)){
			foreach($years as $key =>$values){
				if($years[$key]['label'] == 0){
					$years[$key]['label'] = $msg['faq_facette_no_date'];
				}
			}
			$this->filters['years'] = $years;
		}
		
	}
	
	protected function get_facette_informations($code_champ,$code_ss_champ=0){
		global $dbh, $msg, $charset,$lang;
		$informations = array();
		$query = "select distinct value as label ,authority_num as id,lang,count(id_faq_question) as nb_questions from faq_questions_fields_global_index where id_faq_question in (".implode(",",$this->questions_ids).") and code_champ = '".$code_champ."'";
		if($code_ss_champ){
			$query.= " and code_ss_champ = '".$code_ss_champ."'";
		}
		$query.= " and lang in ('','".$lang."') group by label order by nb_questions desc";
		$result = pmb_mysql_query($query);
		if(pmb_mysql_num_rows($result)>0){
			while ($row = pmb_mysql_fetch_object($result)){
				if(!$row->id){
					$row->id = $row->label;
				}
				$informations[$row->id] = array(
						'id' => $row->id,
						'label' => $row->label,
						'nb_questions' => $row->nb_questions
				);
			}
		}
		return $informations;
	}
	
	protected function get_actives_facettes(){
		global $dbh,$msg,$charset;
		$filter_actives = $facettes_filter = "";

		//thmes
		if(count($this->themes)){
			$themes=new faq_themes("faq_themes", "id_theme", "libelle_theme");
			foreach($this->themes as $theme){
				$facettes_filter.="
					<input type='hidden' id='faq_filters_themes' name='faq_filters[themes][]' value='".$theme."' />";
				$link="javascript:document.getElementById('faq_filters_themes').value='';document.faq_filters.faq_page.value=1;document.faq_filters.submit();";
				$filter_actives.="
						<tr>
							<td>".htmlentities($msg['faq_filter_themes'].": ".$themes->getLabel($theme),ENT_QUOTES,$charset)."</td>
							<td><a href=\"".$link."\"><img src='".get_url_icon('cross.png')."'/></a></td>
						</tr>";				
			}
		}else{
			$facettes_filter.="
					<input type='hidden' id='faq_filters_themes' name='faq_filters[themes][]' value='' />";
		}
		
		//Types
		if(count($this->types)){
			$types=new faq_themes("faq_types", "id_type", "libelle_type");
			foreach($this->types as $type){
				$facettes_filter.="
					<input type='hidden' id='faq_filters_types' name='faq_filters[types][]' value='".$type."' />";
				$link="javascript:document.getElementById('faq_filters_types').value='';document.faq_filters.faq_page.value=1;document.faq_filters.submit();";
				$filter_actives.="
						<tr>
							<td>".htmlentities($msg['faq_filter_types'].": ".$types->getLabel($type),ENT_QUOTES,$charset)."</td>
							<td><a href=\"".$link."\"><img src='".get_url_icon('cross.png')."'/></a></td>
						</tr>";
			}
		}else{
			$facettes_filter.="
					<input type='hidden' id='faq_filters_types' name='faq_filters[types][]' value='' />";
		}
		
		//descripteurs
		if(count($this->descriptors)){
			foreach($this->descriptors as $descriptor){
				$facettes_filter.="
					<input type='hidden' id='faq_filters_descriptors' name='faq_filters[descriptors][]' value='".$descriptor."' />";
				$link="javascript:document.getElementById('faq_filters_descriptors').value='';document.faq_filters.faq_page.value=1;document.faq_filters.submit();";
				$filter_actives.="
						<tr>
							<td>".htmlentities($msg['faq_filter_descriptors'].": ".$this->filters['descriptors'][$descriptor]['label'],ENT_QUOTES,$charset)."</td>
							<td><a href=\"".$link."\"><img src='".get_url_icon('cross.png')."'/></a></td>
						</tr>";
			}
		}else{
			$facettes_filter.="
					<input type='hidden' id='faq_filters_descriptors' name='faq_filters[descriptors][]' value='' />";
		}
		
		if(count($this->years)){
			foreach($this->years as $year){
				$facettes_filter.="
					<input type='hidden' id='faq_filters_years' name='faq_filters[years][]' value='".$year."' />";
				$link="javascript:document.getElementById('faq_filters_years').value='';document.faq_filters.faq_page.value=1;document.faq_filters.submit();";
				$filter_actives.="
						<tr>
							<td>".htmlentities($msg['faq_filter_years'].": ".$this->filters['years'][$year]['label'],ENT_QUOTES,$charset)."</td>
							<td><a href=\"".$link."\"><img src='".get_url_icon('cross.png')."'/></a></td>
						</tr>";
			}
		}else{
			$facettes_filter.="
					<input type='hidden' id='faq_filters_years' name='faq_filters[years][]' value='' />";
		}
		if($filter_actives){
			$facettes_filter.="
				<div class='faq_filters_actives'>
					<h3>".htmlentities($msg['faq_facettes_actives'],ENT_QUOTES,$charset)."</h3>
					<table id='active_facette'>".$filter_actives."
					</table>
				</div>
				<div class='row'>&nbsp;</div>";
		}
		return $facettes_filter;
	}
	
	protected function get_allowed_facettes(){
		global $msg,$charset;
		$facettes_filter = $allowed_facettes= "";
		if(count($this->filters)){
			foreach($this->filters as $filter => $filter_values){
				if(count($filter_values)>1){
					$allowed_facettes.="
					<table>
						<tr>
							<th>".htmlentities($msg['faq_filter_'.$filter],ENT_QUOTES,$charset)."</th>
						</tr>";
					foreach($filter_values as $infos){
						$link="javascript:document.getElementById(\"faq_filters_".$filter."\").value=\"".$infos['id']."\";document.faq_filters.faq_page.value=1;document.faq_filters.submit();";
						$allowed_facettes.="
						<tr>
							<td><a href='".$link."'>".htmlentities($infos['label']." (".$infos['nb_questions'].")",ENT_QUOTES,$charset)."</a></td>
						</tr>";
					}
					$allowed_facettes.="
					</table>";
				}
			}
		}
		if($allowed_facettes){
			$facettes_filter.="
				<div class='faq_filters_allowed'>
					<h3>".htmlentities($msg['facette_list'],ENT_QUOTES,$charset)."</h3>".$allowed_facettes."
				</div>";
		}		
		return $facettes_filter;
	}
	
	protected function get_search_filter(){
		global $msg,$charset;
		
		$facettes_filter = "
		<div class='faq_user_query_filter'>
			<h3>".htmlentities($msg['faq_filter_user_query'],ENT_QUOTES,$charset)."</h3>
			<input type='text' name='faq_filters[user_query]' value='".htmlentities($this->user_query,ENT_QUOTES,$charset)."'/>
			<input type='submit' class='boutonrechercher' name='ok' value='".$msg[142]."'/>
			<div class='row'>&nbsp;</div>
		</div>";
		return $facettes_filter;
	}
	
	public function get_facettes_filter(){
		global $msg,$charset;
		$this->init_filters_infos();
		
		$facettes_filter = "
		<div class='faq_filters' id='facette'>
			<form action='./index.php?lvl=faq' method='post' id='faq_filters' name='faq_filters'>
				<input type='hidden' name='faq_page' value='".htmlentities(($this->page+1),ENT_QUOTES,$charset)."'/>";
		$facettes_filter.= $this->get_search_filter();
		$facettes_filter.= $this->get_actives_facettes();
		$facettes_filter.= $this->get_allowed_facettes();
		$facettes_filter.= "
			</form>
		</div>";
		return $facettes_filter;
	}
}